package com.nokia;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.nokia.dao.UserDao;
import com.nokia.dao.UserRoleCityDao;
import com.nokia.pojo.Role;
import com.nokia.pojo.User;
import com.nokia.pojo.UserRoleCity;
import com.nokia.service.RoleService;
import com.nokia.service.UserService;

/**
 * 操作数据库中的用户信息
 */
@SpringBootTest
public class UserModifyTest {

    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    @Autowired
    private UserService userService;

    @Autowired
    private RoleService roleService;

    @Autowired
    private UserDao userDao;

    @Autowired
    private UserRoleCityDao userRoleCityDao;

    // 清除redis
    @Test
    void test() {
        Boolean delete = redisTemplate.delete("test_token_abc");
        System.out.println(delete);
    }

    // 修改用户--增加黑点库权限
    @Test
    void test1() {
        User user = userService.getByLoginName("test_shijiazhuang");
        // RoleEntity role = new RoleEntity();
        // role.setRoleName("黑点库管理");
        // role = roleService.getOne(Wrappers.query(role));
        // user.getRoles().add(role);
        Role role2 = new Role();
        role2.setRoleName("黑点库查询");
        role2 = roleService.getOne(Wrappers.query(role2));
        user.getRoles().add(role2);
        userService.update(user);
    }

    @Test
    void test2() {
        String str = "{\"no\": \"aaa\"}";
        JSONObject jsonObject = JSON.parseObject(str);
        System.out.println(jsonObject);
        Integer integer = jsonObject.getInteger("no");
        System.out.println(integer);
    }

    // 给12个地市的主管加权限
    @Test
    void test3() {
        // int[] ids = new int[] { 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36 };
        // for (int id : ids) {
        // User user = userDao.selectById(id);
        // System.out.println(user);
        // UserRoleCity userRoleCity = new UserRoleCity();
        // userRoleCity.setUserId(id);
        // userRoleCity.setRoleId(18);
        // userRoleCity.setCityId(user.getCityId());
        // userRoleCityDao.insert(userRoleCity);
        // }

        int[] roleIds = new int[] { 3, 4, 5, 6, 7, 8, 12, 13};
        User user = userDao.selectById(24);
        for (int roleId : roleIds) {
            UserRoleCity userRoleCity = new UserRoleCity();
            userRoleCity.setUserId(user.getUserId());
            userRoleCity.setRoleId(roleId);
            userRoleCity.setCityId(user.getCityId());
            userRoleCityDao.insert(userRoleCity);
        }
    }
}
